<html>
<head>
<title>OGRE: Ogre::SubMesh Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1SubMesh.html">SubMesh</a></div>
<h1>Ogre::SubMesh Class Reference</h1><!-- doxytag: class="Ogre::SubMesh" -->Defines a part of a complete mesh.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1SubMesh-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; unsigned short &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#77002e2ac2d5f5041e4b0fe3bd228245">IndexMap</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Dedicated index map for translate blend index to bone index (only valid if useSharedVertices = false).  <a href="#77002e2ac2d5f5041e4b0fe3bd228245"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef <br>
std::multimap<br>
&lt; size_t,<br>
 <a class="el" href="structOgre_1_1VertexBoneAssignment__s.html">VertexBoneAssignment</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#b396ad138e9d8b48355d495215989881">VertexBoneAssignmentList</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Multimap of verex bone assignments (orders by vertex index).  <a href="#b396ad138e9d8b48355d495215989881"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef <a class="el" href="classOgre_1_1MapIterator.html">MapIterator</a><br>
&lt; <a class="el" href="classOgre_1_1SubMesh.html#b396ad138e9d8b48355d495215989881">VertexBoneAssignmentList</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#9c23baff85d3b4f60e37f2a514be1ada">BoneAssignmentIterator</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef <br>
<a class="el" href="classOgre_1_1ConstMapIterator.html">ConstMapIterator</a><br>
&lt; <a class="el" href="namespaceOgre.html#5dafc9e68bde8099ec5ad6c94e4cf19b">AliasTextureNamePairList</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#243e656daab531eea35d8b9fb5dc3b11">AliasTextureIterator</a></td></tr>

<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#a5e04097716119c5cfed229c8425fc60">SubMesh</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#d0a51b024271c2042968e9e967dd39e8">~SubMesh</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#0764481637920dcb9ccd6474c6a6b8de">setMaterialName</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;matName)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets the name of the <a class="el" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a> which this <a class="el" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a> will use.  <a href="#0764481637920dcb9ccd6474c6a6b8de"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#e9cd0e5fef6d82aba5d5c0bcbcfc65a5">getMaterialName</a> (void) const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#e4d357805749a3193b821a1ff9bca7d1">isMatInitialised</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns true if a material has been assigned to the submesh, otherwise returns false.  <a href="#e4d357805749a3193b821a1ff9bca7d1"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#4770787312a616e8735c5d1a864bb1cb">_getRenderOperation</a> (<a class="el" href="classOgre_1_1RenderOperation.html">RenderOperation</a> &amp;rend, <a class="el" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> lodIndex=0)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns a <a class="el" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a> structure required to render this mesh.  <a href="#4770787312a616e8735c5d1a864bb1cb"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#bdd303710ef1131801f5017ef2eda1f2">addBoneAssignment</a> (const <a class="el" href="structOgre_1_1VertexBoneAssignment__s.html">VertexBoneAssignment</a> &amp;vertBoneAssign)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Assigns a vertex to a bone with a given weight, for skeletal animation.  <a href="#bdd303710ef1131801f5017ef2eda1f2"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#2c29dd4601e67d3f6d26d7d74c017995">clearBoneAssignments</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Removes all bone assignments for this mesh.  <a href="#2c29dd4601e67d3f6d26d7d74c017995"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1MapIterator.html">BoneAssignmentIterator</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#b37844a411ccea1cf06d1c95e10b71e2">getBoneAssignmentIterator</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets an iterator for access all bone assignments.  <a href="#b37844a411ccea1cf06d1c95e10b71e2"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#cd127d162c4271ac6b844161e1ea777a">_compileBoneAssignments</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Must be called once to compile bone assignments into geometry buffer.  <a href="#cd127d162c4271ac6b844161e1ea777a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1ConstMapIterator.html">AliasTextureIterator</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#bafc1dfc5283643f0b5867392f512e3e">getAliasTextureIterator</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets an constant iterator to access all texture alias names assigned to this submesh.  <a href="#bafc1dfc5283643f0b5867392f512e3e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#be04d5342331ad434e47ca9b934a7622">addTextureAlias</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;aliasName, const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;textureName)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Adds the alias or replaces an existing one and associates the texture name to it.  <a href="#be04d5342331ad434e47ca9b934a7622"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#9007b549c95c6fb1402818bf55b65b16">removeTextureAlias</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;aliasName)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Remove a specific texture alias name from the sub mesh.  <a href="#9007b549c95c6fb1402818bf55b65b16"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#8446f2b030ecd536933c0a39cdb3d61a">removeAllTextureAliases</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">removes all texture aliases from the sub mesh  <a href="#8446f2b030ecd536933c0a39cdb3d61a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#776598acc2a9c0d04d9019cd4137d905">hasTextureAliases</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">returns true if the sub mesh has texture aliases  <a href="#776598acc2a9c0d04d9019cd4137d905"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#b80c14813793491559cf24c60f455fd4">getTextureAliasCount</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the number of texture aliases assigned to the sub mesh.  <a href="#b80c14813793491559cf24c60f455fd4"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#2107e531c7161b312571d8977f9539e2">updateMaterialUsingTextureAliases</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The current material used by the submesh is copied into a new material and the submesh's texture aliases are applied if the current texture alias names match those found in the original material.  <a href="#2107e531c7161b312571d8977f9539e2"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#9046e6e0d12c46c57a9056987e9d158e">VertexAnimationType</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#116ae10a9b88b55c44c0583589b15b72">getVertexAnimationType</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the type of any vertex animation used by dedicated geometry.  <a href="#116ae10a9b88b55c44c0583589b15b72"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#f32a20ce7dd6ca470ce7e33e5dc7d7d9">generateExtremes</a> (size_t count)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Generate the submesh extremes (.  <a href="#f32a20ce7dd6ca470ce7e33e5dc7d7d9"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#931e3764e3bf1c3ef7431fc852770fb1">useSharedVertices</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Indicates if this submesh shares vertex data with other meshes or whether it has it's own vertices.  <a href="#931e3764e3bf1c3ef7431fc852770fb1"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1RenderOperation.html#7a272218dae54048c87f31176c19e10d">RenderOperation::OperationType</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#10ed3ef8bb24a001bb89dc9e3cd88c31">operationType</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The render operation type used to render this submesh.  <a href="#10ed3ef8bb24a001bb89dc9e3cd88c31"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#1862a3ec9a3f2ed4ade8af69b41a809d">vertexData</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Dedicated vertex data (only valid if useSharedVertices = false).  <a href="#1862a3ec9a3f2ed4ade8af69b41a809d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#ad428fa6595c7fb01ef7543e5d8d6454">indexData</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Face index data.  <a href="#ad428fa6595c7fb01ef7543e5d8d6454"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1SubMesh.html#77002e2ac2d5f5041e4b0fe3bd228245">IndexMap</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#e6b4c1d0724fe6a9a961b73bd646d3cf">blendIndexToBoneIndexMap</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1ProgressiveMesh.html#0c7f783f655c0691de3ac4a30ac13db2">ProgressiveMesh::LODFaceList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#8d4605861beedf02d1520489ca204bca">mLodFaceList</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">std::vector&lt; <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#c63766998cb839ca582947d7545214f5">extremityPoints</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">A list of extreme points on the submesh (optional).  <a href="#c63766998cb839ca582947d7545214f5"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Mesh.html">Mesh</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#c2b9fd25eb56625716d9e8915f4e0e7d">parent</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Reference to parent <a class="el" href="classOgre_1_1Mesh.html">Mesh</a> (not a smart pointer so child does not keep parent alive).  <a href="#c2b9fd25eb56625716d9e8915f4e0e7d"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#2cf7a582517c07f7330235d3029a2cf8">removeLodLevels</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method for removing LOD data.  <a href="#2cf7a582517c07f7330235d3029a2cf8"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#c9cc28e9a11b69a815fa9b3e52cd76f7">mMaterialName</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Name of the material this <a class="el" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a> uses.  <a href="#c9cc28e9a11b69a815fa9b3e52cd76f7"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#25a7ea86e4beaadd868dacb760330e52">mMatInitialised</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Is there a material yet?  <a href="#25a7ea86e4beaadd868dacb760330e52"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#5dafc9e68bde8099ec5ad6c94e4cf19b">AliasTextureNamePairList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#b1f26bc16b9c1ea567ffcc4548e6466a">mTextureAliases</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">paired list of texture aliases and texture names  <a href="#b1f26bc16b9c1ea567ffcc4548e6466a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1SubMesh.html#b396ad138e9d8b48355d495215989881">VertexBoneAssignmentList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#1e190c3084110b7fa74a208f9c1f29f1">mBoneAssignments</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#97ac0719e0d2a1cd4f0ed4ec48a72912">mBoneAssignmentsOutOfDate</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Flag indicating that bone assignments need to be recompiled.  <a href="#97ac0719e0d2a1cd4f0ed4ec48a72912"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#9046e6e0d12c46c57a9056987e9d158e">VertexAnimationType</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#7b6ef63e9dd8945accbc942307c8fcea">mVertexAnimationType</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Type of vertex animation for dedicated vertex data (populated by <a class="el" href="classOgre_1_1Mesh.html">Mesh</a>).  <a href="#7b6ef63e9dd8945accbc942307c8fcea"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Friends</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#a41a130f156b145bffb3f4b5172c4c93">Mesh</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">class&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#48305c54a01e0c7a3376ea0a077c467f">MeshSerializerImpl</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">class&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#e60e96165c5d5495195fa0d49f031372">MeshSerializerImpl_v1_2</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">class&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SubMesh.html#ef9901d67ded13a151aa3d4fde3a7b17">MeshSerializerImpl_v1_1</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Defines a part of a complete mesh. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Meshes which make up the definition of a discrete 3D object are made up of potentially multiple parts. This is because different parts of the mesh may use different materials or use different vertex formats, such that a rendering state change is required between them. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>Like the <a class="el" href="classOgre_1_1Mesh.html">Mesh</a> class, instatiations of 3D objects in the scene share the <a class="el" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a> instances, and have the option of overriding their material differences on a per-object basis if required. See the <a class="el" href="classOgre_1_1SubEntity.html" title="Utility class which defines the sub-parts of an Entity.">SubEntity</a> class for more information. </dd></dl>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00056">56</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="77002e2ac2d5f5041e4b0fe3bd228245"></a><!-- doxytag: member="Ogre::SubMesh::IndexMap" ref="77002e2ac2d5f5041e4b0fe3bd228245" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;unsigned short&gt; <a class="el" href="classOgre_1_1SubMesh.html#77002e2ac2d5f5041e4b0fe3bd228245">Ogre::SubMesh::IndexMap</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Dedicated index map for translate blend index to bone index (only valid if useSharedVertices = false). 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This data is completely owned by this submesh. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>We collect actually used bones of all bone assignments, and build the blend index in 'packed' form, then the range of the blend index in vertex data VES_BLEND_INDICES element is continuous, with no gaps. Thus, by minimising the world matrix array constants passing to GPU, we can support more bones for a mesh when hardware skinning is used. The hardware skinning support limit is applied to each set of vertex data in the mesh, in other words, the hardware skinning support limit is applied only to the actually used bones of each SubMeshes, not all bones across the entire <a class="el" href="classOgre_1_1Mesh.html">Mesh</a>. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>Because the blend index is different to the bone index, therefore, we use the index map to translate the blend index to bone index. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>The use of shared or non-shared index map is determined when model data is converted to the OGRE .mesh format. </dd></dl>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00104">104</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="b396ad138e9d8b48355d495215989881"></a><!-- doxytag: member="Ogre::SubMesh::VertexBoneAssignmentList" ref="b396ad138e9d8b48355d495215989881" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::multimap&lt;size_t, <a class="el" href="structOgre_1_1VertexBoneAssignment__s.html">VertexBoneAssignment</a>&gt; <a class="el" href="classOgre_1_1SubMesh.html#b396ad138e9d8b48355d495215989881">Ogre::SubMesh::VertexBoneAssignmentList</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Multimap of verex bone assignments (orders by vertex index). 
<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00171">171</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="9c23baff85d3b4f60e37f2a514be1ada"></a><!-- doxytag: member="Ogre::SubMesh::BoneAssignmentIterator" ref="9c23baff85d3b4f60e37f2a514be1ada" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="classOgre_1_1MapIterator.html">MapIterator</a>&lt;<a class="el" href="classOgre_1_1SubMesh.html#b396ad138e9d8b48355d495215989881">VertexBoneAssignmentList</a>&gt; <a class="el" href="classOgre_1_1MapIterator.html">Ogre::SubMesh::BoneAssignmentIterator</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00172">172</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="243e656daab531eea35d8b9fb5dc3b11"></a><!-- doxytag: member="Ogre::SubMesh::AliasTextureIterator" ref="243e656daab531eea35d8b9fb5dc3b11" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="classOgre_1_1ConstMapIterator.html">ConstMapIterator</a>&lt;<a class="el" href="namespaceOgre.html#5dafc9e68bde8099ec5ad6c94e4cf19b">AliasTextureNamePairList</a>&gt; <a class="el" href="classOgre_1_1ConstMapIterator.html">Ogre::SubMesh::AliasTextureIterator</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00183">183</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="a5e04097716119c5cfed229c8425fc60"></a><!-- doxytag: member="Ogre::SubMesh::SubMesh" ref="a5e04097716119c5cfed229c8425fc60" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::SubMesh::SubMesh           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="d0a51b024271c2042968e9e967dd39e8"></a><!-- doxytag: member="Ogre::SubMesh::~SubMesh" ref="d0a51b024271c2042968e9e967dd39e8" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::SubMesh::~SubMesh           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="0764481637920dcb9ccd6474c6a6b8de"></a><!-- doxytag: member="Ogre::SubMesh::setMaterialName" ref="0764481637920dcb9ccd6474c6a6b8de" args="(const String &amp;matName)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::SubMesh::setMaterialName           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>matName</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sets the name of the <a class="el" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a> which this <a class="el" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a> will use. 
<p>

</div>
</div><p>
<a class="anchor" name="e9cd0e5fef6d82aba5d5c0bcbcfc65a5"></a><!-- doxytag: member="Ogre::SubMesh::getMaterialName" ref="e9cd0e5fef6d82aba5d5c0bcbcfc65a5" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; Ogre::SubMesh::getMaterialName           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="e4d357805749a3193b821a1ff9bca7d1"></a><!-- doxytag: member="Ogre::SubMesh::isMatInitialised" ref="e4d357805749a3193b821a1ff9bca7d1" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::SubMesh::isMatInitialised           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns true if a material has been assigned to the submesh, otherwise returns false. 
<p>

</div>
</div><p>
<a class="anchor" name="4770787312a616e8735c5d1a864bb1cb"></a><!-- doxytag: member="Ogre::SubMesh::_getRenderOperation" ref="4770787312a616e8735c5d1a864bb1cb" args="(RenderOperation &amp;rend, ushort lodIndex=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::SubMesh::_getRenderOperation           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RenderOperation.html">RenderOperation</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rend</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a>&nbsp;</td>
          <td class="paramname"> <em>lodIndex</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns a <a class="el" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a> structure required to render this mesh. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>rend</em>&nbsp;</td><td>Reference to a <a class="el" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a> structure to populate. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>lodIndex</em>&nbsp;</td><td>The index of the LOD to use. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="bdd303710ef1131801f5017ef2eda1f2"></a><!-- doxytag: member="Ogre::SubMesh::addBoneAssignment" ref="bdd303710ef1131801f5017ef2eda1f2" args="(const VertexBoneAssignment &amp;vertBoneAssign)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::SubMesh::addBoneAssignment           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1VertexBoneAssignment__s.html">VertexBoneAssignment</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>vertBoneAssign</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Assigns a vertex to a bone with a given weight, for skeletal animation. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This method is only valid after calling setSkeletonName. Since this is a one-off process there exists only 'addBoneAssignment' and 'clearBoneAssignments' methods, no 'editBoneAssignment'. You should not need to modify bone assignments during rendering (only the positions of bones) and OGRE reserves the right to do some internal data reformatting of this information, depending on render system requirements. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>This method is for assigning weights to the dedicated geometry of the <a class="el" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>. To assign weights to the shared <a class="el" href="classOgre_1_1Mesh.html">Mesh</a> geometry, see the equivalent methods on <a class="el" href="classOgre_1_1Mesh.html">Mesh</a>. </dd></dl>

</div>
</div><p>
<a class="anchor" name="2c29dd4601e67d3f6d26d7d74c017995"></a><!-- doxytag: member="Ogre::SubMesh::clearBoneAssignments" ref="2c29dd4601e67d3f6d26d7d74c017995" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::SubMesh::clearBoneAssignments           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Removes all bone assignments for this mesh. 
<p>
<dl class="user" compact><dt><b></b></dt><dd>This method is for assigning weights to the dedicated geometry of the <a class="el" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>. To assign weights to the shared <a class="el" href="classOgre_1_1Mesh.html">Mesh</a> geometry, see the equivalent methods on <a class="el" href="classOgre_1_1Mesh.html">Mesh</a>. </dd></dl>

</div>
</div><p>
<a class="anchor" name="b37844a411ccea1cf06d1c95e10b71e2"></a><!-- doxytag: member="Ogre::SubMesh::getBoneAssignmentIterator" ref="b37844a411ccea1cf06d1c95e10b71e2" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1MapIterator.html">BoneAssignmentIterator</a> Ogre::SubMesh::getBoneAssignmentIterator           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets an iterator for access all bone assignments. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Only valid if this <a class="el" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a> has dedicated geometry. </dd></dl>

</div>
</div><p>
<a class="anchor" name="cd127d162c4271ac6b844161e1ea777a"></a><!-- doxytag: member="Ogre::SubMesh::_compileBoneAssignments" ref="cd127d162c4271ac6b844161e1ea777a" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::SubMesh::_compileBoneAssignments           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Must be called once to compile bone assignments into geometry buffer. 
<p>

</div>
</div><p>
<a class="anchor" name="bafc1dfc5283643f0b5867392f512e3e"></a><!-- doxytag: member="Ogre::SubMesh::getAliasTextureIterator" ref="bafc1dfc5283643f0b5867392f512e3e" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ConstMapIterator.html">AliasTextureIterator</a> Ogre::SubMesh::getAliasTextureIterator           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets an constant iterator to access all texture alias names assigned to this submesh. 
<p>

</div>
</div><p>
<a class="anchor" name="be04d5342331ad434e47ca9b934a7622"></a><!-- doxytag: member="Ogre::SubMesh::addTextureAlias" ref="be04d5342331ad434e47ca9b934a7622" args="(const String &amp;aliasName, const String &amp;textureName)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::SubMesh::addTextureAlias           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>aliasName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>textureName</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Adds the alias or replaces an existing one and associates the texture name to it. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The submesh uses the texture alias to replace textures used in the material applied to the submesh. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>aliasName</em>&nbsp;</td><td>is the name of the alias. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>textureName</em>&nbsp;</td><td>is the name of the texture to be associated with the alias </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="9007b549c95c6fb1402818bf55b65b16"></a><!-- doxytag: member="Ogre::SubMesh::removeTextureAlias" ref="9007b549c95c6fb1402818bf55b65b16" args="(const String &amp;aliasName)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::SubMesh::removeTextureAlias           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>aliasName</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Remove a specific texture alias name from the sub mesh. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>aliasName</em>&nbsp;</td><td>is the name of the alias to be removed. If it is not found then it is ignored. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="8446f2b030ecd536933c0a39cdb3d61a"></a><!-- doxytag: member="Ogre::SubMesh::removeAllTextureAliases" ref="8446f2b030ecd536933c0a39cdb3d61a" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::SubMesh::removeAllTextureAliases           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
removes all texture aliases from the sub mesh 
<p>

</div>
</div><p>
<a class="anchor" name="776598acc2a9c0d04d9019cd4137d905"></a><!-- doxytag: member="Ogre::SubMesh::hasTextureAliases" ref="776598acc2a9c0d04d9019cd4137d905" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::SubMesh::hasTextureAliases           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
returns true if the sub mesh has texture aliases 
<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00210">210</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="b80c14813793491559cf24c60f455fd4"></a><!-- doxytag: member="Ogre::SubMesh::getTextureAliasCount" ref="b80c14813793491559cf24c60f455fd4" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t Ogre::SubMesh::getTextureAliasCount           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the number of texture aliases assigned to the sub mesh. 
<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00213">213</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="2107e531c7161b312571d8977f9539e2"></a><!-- doxytag: member="Ogre::SubMesh::updateMaterialUsingTextureAliases" ref="2107e531c7161b312571d8977f9539e2" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::SubMesh::updateMaterialUsingTextureAliases           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The current material used by the submesh is copied into a new material and the submesh's texture aliases are applied if the current texture alias names match those found in the original material. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The submesh's texture aliases must be setup prior to calling this method. If a new material has to be created, the subMesh autogenerates the new name. The new name is the old name + "_" + number. </dd></dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>True if texture aliases were applied and a new material was created. </dd></dl>

</div>
</div><p>
<a class="anchor" name="116ae10a9b88b55c44c0583589b15b72"></a><!-- doxytag: member="Ogre::SubMesh::getVertexAnimationType" ref="116ae10a9b88b55c44c0583589b15b72" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#9046e6e0d12c46c57a9056987e9d158e">VertexAnimationType</a> Ogre::SubMesh::getVertexAnimationType           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get the type of any vertex animation used by dedicated geometry. 
<p>

</div>
</div><p>
<a class="anchor" name="f32a20ce7dd6ca470ce7e33e5dc7d7d9"></a><!-- doxytag: member="Ogre::SubMesh::generateExtremes" ref="f32a20ce7dd6ca470ce7e33e5dc7d7d9" args="(size_t count)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::SubMesh::generateExtremes           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>count</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Generate the submesh extremes (. 
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1SubMesh.html#c63766998cb839ca582947d7545214f5" title="A list of extreme points on the submesh (optional).">extremityPoints</a>). </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>count</em>&nbsp;</td><td>Number of extreme points to compute for the submesh. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="2cf7a582517c07f7330235d3029a2cf8"></a><!-- doxytag: member="Ogre::SubMesh::removeLodLevels" ref="2cf7a582517c07f7330235d3029a2cf8" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::SubMesh::removeLodLevels           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method for removing LOD data. 
<p>

</div>
</div><p>
<hr><h2>Friends And Related Function Documentation</h2>
<a class="anchor" name="a41a130f156b145bffb3f4b5172c4c93"></a><!-- doxytag: member="Ogre::SubMesh::Mesh" ref="a41a130f156b145bffb3f4b5172c4c93" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOgre_1_1Mesh.html">Mesh</a><code> [friend]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00058">58</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="48305c54a01e0c7a3376ea0a077c467f"></a><!-- doxytag: member="Ogre::SubMesh::MeshSerializerImpl" ref="48305c54a01e0c7a3376ea0a077c467f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOgre_1_1MeshSerializerImpl.html">MeshSerializerImpl</a><code> [friend]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00059">59</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="e60e96165c5d5495195fa0d49f031372"></a><!-- doxytag: member="Ogre::SubMesh::MeshSerializerImpl_v1_2" ref="e60e96165c5d5495195fa0d49f031372" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOgre_1_1MeshSerializerImpl__v1__2.html">MeshSerializerImpl_v1_2</a><code> [friend]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00060">60</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="ef9901d67ded13a151aa3d4fde3a7b17"></a><!-- doxytag: member="Ogre::SubMesh::MeshSerializerImpl_v1_1" ref="ef9901d67ded13a151aa3d4fde3a7b17" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOgre_1_1MeshSerializerImpl__v1__1.html">MeshSerializerImpl_v1_1</a><code> [friend]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00061">61</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="931e3764e3bf1c3ef7431fc852770fb1"></a><!-- doxytag: member="Ogre::SubMesh::useSharedVertices" ref="931e3764e3bf1c3ef7431fc852770fb1" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1SubMesh.html#931e3764e3bf1c3ef7431fc852770fb1">Ogre::SubMesh::useSharedVertices</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Indicates if this submesh shares vertex data with other meshes or whether it has it's own vertices. 
<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00068">68</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="10ed3ef8bb24a001bb89dc9e3cd88c31"></a><!-- doxytag: member="Ogre::SubMesh::operationType" ref="10ed3ef8bb24a001bb89dc9e3cd88c31" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RenderOperation.html#7a272218dae54048c87f31176c19e10d">RenderOperation::OperationType</a> <a class="el" href="classOgre_1_1SubMesh.html#10ed3ef8bb24a001bb89dc9e3cd88c31">Ogre::SubMesh::operationType</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The render operation type used to render this submesh. 
<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00071">71</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="1862a3ec9a3f2ed4ade8af69b41a809d"></a><!-- doxytag: member="Ogre::SubMesh::vertexData" ref="1862a3ec9a3f2ed4ade8af69b41a809d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a>* <a class="el" href="classOgre_1_1SubMesh.html#1862a3ec9a3f2ed4ade8af69b41a809d">Ogre::SubMesh::vertexData</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Dedicated vertex data (only valid if useSharedVertices = false). 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This data is completely owned by this submesh. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>The use of shared or non-shared buffers is determined when model data is converted to the OGRE .mesh format. </dd></dl>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00080">80</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="ad428fa6595c7fb01ef7543e5d8d6454"></a><!-- doxytag: member="Ogre::SubMesh::indexData" ref="ad428fa6595c7fb01ef7543e5d8d6454" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1IndexData.html">IndexData</a>* <a class="el" href="classOgre_1_1SubMesh.html#ad428fa6595c7fb01ef7543e5d8d6454">Ogre::SubMesh::indexData</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Face index data. 
<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00083">83</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="e6b4c1d0724fe6a9a961b73bd646d3cf"></a><!-- doxytag: member="Ogre::SubMesh::blendIndexToBoneIndexMap" ref="e6b4c1d0724fe6a9a961b73bd646d3cf" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1SubMesh.html#77002e2ac2d5f5041e4b0fe3bd228245">IndexMap</a> <a class="el" href="classOgre_1_1SubMesh.html#e6b4c1d0724fe6a9a961b73bd646d3cf">Ogre::SubMesh::blendIndexToBoneIndexMap</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00105">105</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="8d4605861beedf02d1520489ca204bca"></a><!-- doxytag: member="Ogre::SubMesh::mLodFaceList" ref="8d4605861beedf02d1520489ca204bca" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ProgressiveMesh.html#0c7f783f655c0691de3ac4a30ac13db2">ProgressiveMesh::LODFaceList</a> <a class="el" href="classOgre_1_1SubMesh.html#8d4605861beedf02d1520489ca204bca">Ogre::SubMesh::mLodFaceList</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00107">107</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="c63766998cb839ca582947d7545214f5"></a><!-- doxytag: member="Ogre::SubMesh::extremityPoints" ref="c63766998cb839ca582947d7545214f5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&gt; <a class="el" href="classOgre_1_1SubMesh.html#c63766998cb839ca582947d7545214f5">Ogre::SubMesh::extremityPoints</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
A list of extreme points on the submesh (optional). 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>These points are some arbitrary points on the mesh that are used by engine to better sort submeshes by depth. This doesn't matter much for non-transparent submeshes, as Z-buffer takes care of invisible surface culling anyway, but is pretty useful for semi-transparent submeshes because the order in which transparent submeshes must be rendered cannot be always correctly deduced from entity position. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>These points are intelligently chosen from the points that make up the submesh, the criteria for choosing them should be that these points somewhat characterize the submesh outline, e.g. they should not be close to each other, and they should be on the outer hull of the submesh. They can be stored in the .mesh file, or generated at runtime (see generateExtremes ()). </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>If this array is empty, submesh sorting is done like in older versions - by comparing the positions of the owning entity. </dd></dl>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00128">128</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="c2b9fd25eb56625716d9e8915f4e0e7d"></a><!-- doxytag: member="Ogre::SubMesh::parent" ref="c2b9fd25eb56625716d9e8915f4e0e7d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Mesh.html">Mesh</a>* <a class="el" href="classOgre_1_1SubMesh.html#c2b9fd25eb56625716d9e8915f4e0e7d">Ogre::SubMesh::parent</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Reference to parent <a class="el" href="classOgre_1_1Mesh.html">Mesh</a> (not a smart pointer so child does not keep parent alive). 
<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00131">131</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="c9cc28e9a11b69a815fa9b3e52cd76f7"></a><!-- doxytag: member="Ogre::SubMesh::mMaterialName" ref="c9cc28e9a11b69a815fa9b3e52cd76f7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1SubMesh.html#c9cc28e9a11b69a815fa9b3e52cd76f7">Ogre::SubMesh::mMaterialName</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Name of the material this <a class="el" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a> uses. 
<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00240">240</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="25a7ea86e4beaadd868dacb760330e52"></a><!-- doxytag: member="Ogre::SubMesh::mMatInitialised" ref="25a7ea86e4beaadd868dacb760330e52" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1SubMesh.html#25a7ea86e4beaadd868dacb760330e52">Ogre::SubMesh::mMatInitialised</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Is there a material yet? 
<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00243">243</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="b1f26bc16b9c1ea567ffcc4548e6466a"></a><!-- doxytag: member="Ogre::SubMesh::mTextureAliases" ref="b1f26bc16b9c1ea567ffcc4548e6466a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#5dafc9e68bde8099ec5ad6c94e4cf19b">AliasTextureNamePairList</a> <a class="el" href="classOgre_1_1SubMesh.html#b1f26bc16b9c1ea567ffcc4548e6466a">Ogre::SubMesh::mTextureAliases</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
paired list of texture aliases and texture names 
<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00246">246</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="1e190c3084110b7fa74a208f9c1f29f1"></a><!-- doxytag: member="Ogre::SubMesh::mBoneAssignments" ref="1e190c3084110b7fa74a208f9c1f29f1" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1SubMesh.html#b396ad138e9d8b48355d495215989881">VertexBoneAssignmentList</a> <a class="el" href="classOgre_1_1SubMesh.html#1e190c3084110b7fa74a208f9c1f29f1">Ogre::SubMesh::mBoneAssignments</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00248">248</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="97ac0719e0d2a1cd4f0ed4ec48a72912"></a><!-- doxytag: member="Ogre::SubMesh::mBoneAssignmentsOutOfDate" ref="97ac0719e0d2a1cd4f0ed4ec48a72912" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1SubMesh.html#97ac0719e0d2a1cd4f0ed4ec48a72912">Ogre::SubMesh::mBoneAssignmentsOutOfDate</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Flag indicating that bone assignments need to be recompiled. 
<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00251">251</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="7b6ef63e9dd8945accbc942307c8fcea"></a><!-- doxytag: member="Ogre::SubMesh::mVertexAnimationType" ref="7b6ef63e9dd8945accbc942307c8fcea" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#9046e6e0d12c46c57a9056987e9d158e">VertexAnimationType</a> <a class="el" href="classOgre_1_1SubMesh.html#7b6ef63e9dd8945accbc942307c8fcea">Ogre::SubMesh::mVertexAnimationType</a><code> [mutable, protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Type of vertex animation for dedicated vertex data (populated by <a class="el" href="classOgre_1_1Mesh.html">Mesh</a>). 
<p>

<p>Definition at line <a class="el" href="OgreSubMesh_8h-source.html#l00254">254</a> of file <a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreSubMesh_8h-source.html">OgreSubMesh.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:54:22 2008
</p>
</body>
</html>
